package hideandseek.listeners;

import java.lang.invoke.CallSite;
import java.lang.reflect.UndeclaredThrowableException;
import java.lang.invoke.MethodHandle;
import java.lang.invoke.StringConcatFactory;
import java.lang.invoke.MethodType;
import java.lang.invoke.MethodHandles;
import org.bukkit.command.CommandSender;
import org.bukkit.event.server.ServerListPingEvent;
import org.bukkit.event.player.PlayerTeleportEvent;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.event.player.PlayerChatEvent;
import org.bukkit.event.player.PlayerRespawnEvent;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.World;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.event.entity.ProjectileLaunchEvent;
import org.bukkit.projectiles.ProjectileSource;
import org.bukkit.entity.Projectile;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.inventory.meta.FireworkMeta;
import com.google.common.io.ByteArrayDataOutput;
import org.bukkit.inventory.Inventory;
import org.bukkit.util.Vector;
import org.bukkit.block.BlockState;
import org.bukkit.entity.EntityType;
import java.util.HashMap;
import org.bukkit.metadata.MetadataValue;
import org.bukkit.metadata.FixedMetadataValue;
import org.bukkit.entity.TNTPrimed;
import org.bukkit.Color;
import org.bukkit.FireworkEffect;
import hideandseek.managers.AchievementsManager;
import org.bukkit.plugin.Plugin;
import com.google.common.io.ByteStreams;
import hideandseek.xseries.XMaterial;
import java.util.Collection;
import java.util.ArrayList;
import hideandseek.Customization;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.Bukkit;
import hideandseek.Perk;
import org.bukkit.Material;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.entity.FoodLevelChangeEvent;
import java.util.Iterator;
import java.util.List;
import org.bukkit.entity.Item;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;
import org.bukkit.inventory.ItemStack;
import org.bukkit.Effect;
import org.bukkit.Location;
import hideandseek.utils.Utils;
import org.bukkit.entity.Firework;
import org.bukkit.event.player.PlayerPickupItemEvent;
import org.bukkit.event.player.PlayerDropItemEvent;
import org.bukkit.entity.Entity;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import hideandseek.managers.FilesManager;
import org.bukkit.block.Sign;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.ChatColor;
import hideandseek.PlayerData;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.EventHandler;
import org.bukkit.entity.Player;
import hideandseek.Arena;
import hideandseek.Config;
import org.bukkit.event.player.PlayerLoginEvent;
import hideandseek.HideAndSeek;
import org.bukkit.event.Listener;

public class HASListener implements Listener
{
    private final HideAndSeek plugin;
    
    public HASListener(final HideAndSeek var1) {
        this.plugin = var1;
    }
    
    @EventHandler
    public void onPlayerLogin(final PlayerLoginEvent var1) {
        final Player var2 = var1.getPlayer();
        if (Config.getInstance().bungeeEnabled) {
            if (Arena.arenaObjects.size() == 0) {
                var1.disallow(PlayerLoginEvent.Result.KICK_OTHER, (String)this.plugin.customization.messages.get("no_arenas"));
                return;
            }
            boolean var3 = false;
            if (this.plugin.bungeeMode.selectedArena != null) {
                if (!this.plugin.spectateEnabled || (this.plugin.bungeeMode.selectedArena.state != Arena.ArenaState.INGAME && this.plugin.bungeeMode.selectedArena.state != Arena.ArenaState.ENDING)) {
                    var1.disallow(PlayerLoginEvent.Result.KICK_OTHER, (String)this.plugin.customization.messages.get("arena_not_available"));
                    return;
                }
                var3 = true;
            }
            if (var1.getResult().equals((Object)PlayerLoginEvent.Result.KICK_FULL) && (var2.hasPermission("hideandseek.joinfull") || var3)) {
                var1.setResult(PlayerLoginEvent.Result.ALLOWED);
            }
        }
    }
    
    @EventHandler
    public void onPlayerJoin(final PlayerJoinEvent var1) {
        final Player var2 = var1.getPlayer();
        this.plugin.playerData.put(var2.getName(), new PlayerData(var2));
        if (Config.getInstance().bungeeEnabled) {
            var1.setJoinMessage((String)null);
            if (this.plugin.bungeeMode.selectedArena != null) {
                if (this.plugin.spectateEnabled && (this.plugin.bungeeMode.selectedArena.state == Arena.ArenaState.INGAME || this.plugin.bungeeMode.selectedArena.state == Arena.ArenaState.ENDING)) {
                    this.plugin.spectatorJoin(var2, this.plugin.bungeeMode.selectedArena);
                }
            }
            else {
                this.plugin.bungeeMode.join(var2, false);
            }
        }
        if (var2.hasPermission("hideandseek.admin")) {
            if (this.plugin.availableUpdate) {
                var2.sendMessage(this.plugin.customization.prefix + "发现一个新版本! " + String.valueOf(ChatColor.LIGHT_PURPLE) + "请到xxx下载");
            }
            else {
                this.plugin.checkUpdates(var2);
            }
        }
    }
    
    @EventHandler
    public void onPlayerLeave(final PlayerQuitEvent var1) {
        final Player var2 = var1.getPlayer();
        this.plugin.playerData.get(var2.getName()).saveStats(var2, true);
        if (this.plugin.game.contains(var2.getName())) {
            if (Config.getInstance().bungeeEnabled) {
                var1.setQuitMessage((String)null);
                this.plugin.bungeeMode.leave(var2);
            }
            else {
                var2.performCommand("has leave");
            }
        }
        this.plugin.playerData.remove(var2.getName());
    }
    
    @EventHandler
    public void onBlockBreak(final BlockBreakEvent var1) {
        final Player var2 = var1.getPlayer();
        if (this.plugin.game.contains(var2.getName()) && !this.plugin.editmode.contains(var2.getName())) {
            var1.setCancelled(true);
        }
        else if (var1.getBlock().getState() instanceof Sign && !var1.isCancelled()) {
            final Sign var3 = (Sign)var1.getBlock().getState();
            if (var3.getLine(0).equals(this.plugin.customization.sign_prefix)) {
                if (!var2.hasPermission("hideandseek.breaksigns")) {
                    var2.sendMessage((String)this.plugin.customization.messages.get("no_permission"));
                    var1.setCancelled(true);
                    return;
                }
                if (var3.getLine(1).contains("Top #")) {
                    final int var4 = Integer.valueOf(var3.getLine(1).split("#")[1]);
                    if (FilesManager.getInstance().getConfig("signs.yml").contains("Signs.Top." + var4)) {
                        FilesManager.getInstance().getConfig("signs.yml").set("Signs.Top." + var4, (Object)null);
                        FilesManager.getInstance().saveConfig("signs.yml");
                        var2.sendMessage(this.plugin.customization.prefix + "你" + String.valueOf(ChatColor.GREEN) + "成功" + String.valueOf(ChatColor.GOLD) + "移除了一个排行榜告示牌!");
                    }
                    final boolean var5 = this.plugin.updater != null;
                    this.plugin.fixUpdater();
                    if (var5 && this.plugin.updater == null) {
                        var2.sendMessage(this.plugin.customization.prefix + "告示牌更新已停止");
                    }
                    return;
                }
                final Arena var6 = Arena.valueOf(ChatColor.stripColor(var3.getLine(1)));
                if (var6 != null) {
                    var6.sign = null;
                    var6.updateBehindSign();
                    FilesManager.getInstance().getConfig("signs.yml").set("Signs.Join." + var6.name, (Object)null);
                    FilesManager.getInstance().saveConfig("signs.yml");
                    var2.sendMessage(this.plugin.customization.prefix + "你" + String.valueOf(ChatColor.GREEN) + "成功" + String.valueOf(ChatColor.GOLD) + "移除了一个\"加入游戏\"告示牌!");
                }
            }
        }
    }
    
    @EventHandler
    public void onBlockPlace(final BlockPlaceEvent var1) {
        final Player var2 = var1.getPlayer();
        if (this.plugin.game.contains(var2.getName()) && !this.plugin.editmode.contains(var2.getName())) {
            var1.setCancelled(true);
        }
    }
    
    @EventHandler
    public void onBombExpload(final EntityExplodeEvent var1) {
        final Entity var2 = var1.getEntity();
        if (var2 != null && (var2.hasMetadata("damageSeekers") || var2.hasMetadata("damageHiders"))) {
            var1.blockList().clear();
        }
    }
    
    @EventHandler
    public void onPlayerDropItem(final PlayerDropItemEvent var1) {
        if (this.plugin.game.contains(var1.getPlayer().getName())) {
            var1.setCancelled(true);
        }
    }
    
    @EventHandler
    public void onPlayerPickUpItems(final PlayerPickupItemEvent var1) {
        final Player var2 = var1.getPlayer();
        if (this.plugin.game.contains(var2.getName())) {
            var1.setCancelled(true);
            final Item var3 = var1.getItem();
            if (!var3.getItemStack().getItemMeta().hasDisplayName()) {
                return;
            }
            if (var3.getItemStack().getItemMeta().getDisplayName().contains(this.plugin.powerup_marker)) {
                final Arena var4 = this.plugin.playerData.get(var2.getName()).arena;
                if (var4.hiders.contains(var2.getName())) {
                    var3.getWorld().spawn(var3.getLocation(), (Class)Firework.class);
                    final List var5 = Utils.getCircle(var3.getLocation(), Integer.valueOf(5), Integer.valueOf(2), Boolean.valueOf(false), Boolean.valueOf(false), 1);
                    for (final Location var7 : var5) {
                        var7.getWorld().playEffect(var7, Effect.MOBSPAWNER_FLAMES, 1);
                    }
                    var2.getInventory().addItem(new ItemStack[] { var3.getItemStack() });
                    var3.remove();
                    var2.addPotionEffect(new PotionEffect(PotionEffectType.SLOW, 40, 10));
                    final String var8 = this.plugin.customization.messages.get("powerup_pick").replace("%player%", var2.getName());
                    for (final Player var10 : var4.getPlayers(true)) {
                        var10.sendMessage(var8);
                        Utils.playSound(var10, "Powerup-Pickup");
                    }
                }
            }
        }
    }
    
    @EventHandler
    public void onPlayerLoseFood(final FoodLevelChangeEvent var1) {
        if (this.plugin.game.contains(var1.getEntity().getName())) {
            var1.setCancelled(true);
        }
    }
    
    @EventHandler
    public void onPlayerInteract(final PlayerInteractEvent var1) {
        final Player var2 = var1.getPlayer();
        if (var1.getAction().equals((Object)Action.RIGHT_CLICK_BLOCK) && var1.getClickedBlock().getState() instanceof Sign) {
            final Sign var3 = (Sign)var1.getClickedBlock().getState();
            if (var3.getLine(0).equals(this.plugin.customization.sign_prefix)) {
                final PlayerData var4 = this.plugin.playerData.get(var2.getName());
                if (var4.hasCooldown(var2, "signs", 3, true)) {
                    return;
                }
                final String var5 = var3.getLine(1);
                if (var5.contains("Top #")) {
                    return;
                }
                if (var5.equals(this.plugin.customization.sign_stats)) {
                    var2.performCommand("has stats");
                    return;
                }
                if (var5.equals(this.plugin.customization.sign_shop)) {
                    if (this.plugin.game.contains(var2.getName())) {
                        this.plugin.shopping.add(var2.getName());
                        var2.openInventory(this.plugin.shopInventory);
                    }
                    else {
                        var2.sendMessage((String)this.plugin.customization.messages.get("not_in_game"));
                    }
                    return;
                }
                if (var5.equals(this.plugin.customization.sign_autojoin)) {
                    var2.performCommand("has autojoin");
                    var2.updateInventory();
                    return;
                }
                if (var5.equals(this.plugin.customization.sign_leave)) {
                    if (var2.getItemInHand().getType() != Material.AIR) {
                        var2.sendMessage((String)this.plugin.customization.messages.get("empty_hand_sign_error"));
                        return;
                    }
                    var2.performCommand("has leave");
                    var2.updateInventory();
                }
                else {
                    if (var5.equals(this.plugin.customization.sign_join_default)) {
                        if (this.plugin.joinGui != null) {
                            var2.performCommand("has join");
                        }
                        return;
                    }
                    final Arena var6 = Arena.valueOf(ChatColor.stripColor(var5));
                    if (var6 != null) {
                        if (var2.getItemInHand().getType() != Material.AIR) {
                            var2.sendMessage((String)this.plugin.customization.messages.get("empty_hand_sign_error"));
                            return;
                        }
                        var2.performCommand("has join " + var6.name);
                        var2.updateInventory();
                    }
                }
            }
        }
        else if (this.plugin.game.contains(var2.getName())) {
            if (var1.getAction().equals((Object)Action.RIGHT_CLICK_AIR) || var1.getAction().equals((Object)Action.RIGHT_CLICK_BLOCK)) {
                final ItemStack var7 = var2.getItemInHand();
                if (var7.getType() != Material.AIR) {
                    if (var7.getItemMeta().hasDisplayName() && var7.getItemMeta().getDisplayName().contains("Mob: ")) {
                        var1.setCancelled(true);
                        return;
                    }
                    if (var7.getType().equals((Object)Perk.DisguiseSelector.purchased.getType()) || (var7.getType().equals((Object)Perk.DisguiseChanger.purchased.getType()) && var7.hasItemMeta() && var7.getItemMeta().hasDisplayName() && var7.getItemMeta().getDisplayName().equals(Perk.DisguiseChanger.purchased.getItemMeta().getDisplayName()))) {
                        var1.setCancelled(true);
                        final Arena var8 = this.plugin.playerData.get(var2.getName()).arena;
                        final PlayerData var9 = this.plugin.playerData.get(var2.getName());
                        if (var9.specialBlocks.isEmpty()) {
                            var2.openInventory(var8.disguisesInventory);
                        }
                        else {
                            final int var10 = var8.disguises.size() + var9.specialBlocks.size();
                            final int var11 = (var10 < 10) ? 9 : ((var10 < 19) ? 18 : ((var10 < 28) ? 27 : ((var10 < 37) ? 36 : ((var10 < 46) ? 45 : 54))));
                            final Inventory var12 = Bukkit.createInventory((InventoryHolder)null, var11, (String)this.plugin.customization.inventories.get("Disguise-Selector"));
                            for (final ItemStack var14 : var8.disguises) {
                                var12.addItem(new ItemStack[] { var14 });
                            }
                            for (final ItemStack var14 : var9.specialBlocks) {
                                var12.addItem(new ItemStack[] { var14 });
                            }
                            var2.openInventory(var12);
                        }
                        return;
                    }
                    if (Utils.compareItem(var7, (ItemStack)Customization.getInstance().items.get("Vote"))) {
                        var1.setCancelled(true);
                        if (Config.getInstance().bungeeEnabled) {
                            final Inventory var15 = Bukkit.createInventory((InventoryHolder)null, 18, String.valueOf(ChatColor.DARK_RED) + "Vote");
                            final ArrayList var16 = new ArrayList(this.plugin.playerData.get(var2.getName()).votes);
                            final ArrayList var17 = new ArrayList();
                            int var11 = 9;
                            for (Arena var19 : Arena.arenaObjects) {
                                var15.addItem(new ItemStack[] { var19.voteItem });
                                byte var20 = 7;
                                for (final String var22 : var16) {
                                    if (var22.equals(var19.name)) {
                                        var17.add(var19.name);
                                    }
                                }
                                var16.removeAll(var17);
                                if (var17.size() == 1) {
                                    var20 = 5;
                                }
                                if (var17.size() == 2) {
                                    var20 = 4;
                                }
                                if (var17.size() == 3) {
                                    var20 = 14;
                                }
                                var17.clear();
                                var15.setItem(var11, XMaterial.matchXMaterial("STAINED_GLASS_PANE:" + var20).get().parseItem());
                                ++var11;
                            }
                            var2.openInventory(var15);
                        }
                        return;
                    }
                    if (Utils.compareItem(var7, (ItemStack)Customization.getInstance().items.get("Quit"))) {
                        var1.setCancelled(true);
                        if (Config.getInstance().bungeeEnabled) {
                            final ByteArrayDataOutput var23 = ByteStreams.newDataOutput();
                            var23.writeUTF("Connect");
                            var23.writeUTF(this.plugin.bungeeMode.hub);
                            var2.sendPluginMessage((Plugin)this.plugin, "BungeeCord", var23.toByteArray());
                        }
                        else {
                            var2.performCommand("has leave");
                            var2.updateInventory();
                        }
                        return;
                    }
                    if (Utils.compareItem(var7, (ItemStack)Customization.getInstance().items.get("Shop"))) {
                        var1.setCancelled(true);
                        this.plugin.shopping.add(var2.getName());
                        var2.openInventory(this.plugin.shopInventory);
                        return;
                    }
                    if (Utils.compareItem(var7, (ItemStack)Customization.getInstance().items.get("Achievements"))) {
                        var1.setCancelled(true);
                        final PlayerData var4 = HideAndSeek.getInstance().playerData.get(var2.getName());
                        (var4.achievements = AchievementsManager.getInstance().getAchievementsInventory(var4)).open(var2);
                        return;
                    }
                    if (Utils.compareItem(var7, (ItemStack)Customization.getInstance().items.get("Trails"))) {
                        if (this.plugin.trailsInventory != null) {
                            var2.openInventory(this.plugin.trailsInventory);
                        }
                        return;
                    }
                    if (var7.getType().equals((Object)this.plugin.firework.getType())) {
                        var1.setCancelled(true);
                        final PlayerData var4 = this.plugin.playerData.get(var2.getName());
                        if (!var4.arena.canUsefireWorks) {
                            var2.sendMessage((String)this.plugin.customization.messages.get("fireworks_unavailable"));
                            return;
                        }
                        if (var4.hasCooldown(var2, "firework", Config.getInstance().fireworksCooldown, true)) {
                            return;
                        }
                        final Firework var24 = (Firework)var2.getWorld().spawn(var2.getLocation(), (Class)Firework.class);
                        final FireworkMeta var25 = var24.getFireworkMeta();
                        var25.setPower(2);
                        final FireworkEffect.Type var26 = FireworkEffect.Type.BALL_LARGE;
                        final FireworkEffect var27 = FireworkEffect.builder().flicker(true).withColor(Color.fromBGR(Utils.random.nextInt(256), Utils.random.nextInt(256), Utils.random.nextInt(256))).with(var26).trail(true).build();
                        var25.addEffect(var27);
                        var24.setFireworkMeta(var25);
                        final int var28 = var4.modifier * Config.getInstance().fireworksGivenCoins;
                        var4.addCoins(var2, var28);
                        final PlayerData playerData = var4;
                        playerData.currentGameCoins += var28;
                        final PlayerData playerData2 = var4;
                        ++playerData2.currentGameFireworks;
                        var2.sendMessage(this.plugin.customization.messages.get("firework_use").replace("%earnedCoins%", String.valueOf(var28)) + ((var4.modifier != 1) ? (String.valueOf(ChatColor.YELLOW) + " (x" + var4.modifier) : ""));
                        if (var2.getItemInHand().getAmount() > 1) {
                            var2.getItemInHand().setAmount(var2.getItemInHand().getAmount() - 1);
                        }
                        else {
                            var2.setItemInHand(new ItemStack(Material.AIR));
                        }
                        return;
                    }
                    else {
                        if (this.plugin.playerData.get(var2.getName()).arena.seekers.contains(var2.getName())) {
                            if (var7.getType().equals((Object)Material.DIAMOND_AXE) || var7.getType().equals((Object)Material.IRON_AXE)) {
                                var1.setCancelled(true);
                                final PlayerData var4 = this.plugin.playerData.get(var2.getName());
                                if (var4.hasCooldown(var2, "leap", Config.getInstance().LeapCooldown, true)) {
                                    return;
                                }
                                var2.setVelocity(var2.getEyeLocation().getDirection().multiply(Config.getInstance().leapMultiplier));
                                return;
                            }
                            else if (var2.getItemInHand().getType().equals((Object)Perk.ThrowableTNT.purchased.getType())) {
                                var1.setCancelled(true);
                                final PlayerData var4 = this.plugin.playerData.get(var2.getName());
                                if (var4.hasCooldown(var2, "throwabletnt", Config.getInstance().ThrowabbleTNTCooldown, true)) {
                                    return;
                                }
                                final TNTPrimed var29 = (TNTPrimed)var2.getWorld().spawn(var2.getLocation().add(0.0, 1.0, 0.0), (Class)TNTPrimed.class);
                                var29.setMetadata("damageHiders", (MetadataValue)new FixedMetadataValue((Plugin)this.plugin, (Object)true));
                                var29.setVelocity(var2.getEyeLocation().getDirection().setY(0.3).multiply(1.5));
                                var29.setFuseTicks(30);
                                return;
                            }
                            else if (var2.getItemInHand().getType().equals((Object)Perk.DisguisesDetector.purchased.getType())) {
                                var1.setCancelled(true);
                                final PlayerData var4 = this.plugin.playerData.get(var2.getName());
                                if (var4.hasCooldown(var2, "disguisedetector", Config.getInstance().DisguiseDetectorCooldown, true)) {
                                    return;
                                }
                                final Arena var30 = this.plugin.playerData.get(var2.getName()).arena;
                                final HashMap var31 = new HashMap();
                                for (final Player var33 : var30.getHiders()) {
                                    var31.put(var33.getName(), Math.ceil(var2.getLocation().distance(var33.getLocation())));
                                }
                                var2.sendMessage(String.valueOf(ChatColor.DARK_AQUA) + "      =================================== ");
                                var2.sendMessage(" ");
                                int var11 = 0;
                                for (String var34 : var31.keySet()) {
                                    if (var11 == 5) {
                                        break;
                                    }
                                    var2.sendMessage("      " + String.valueOf(ChatColor.YELLOW) + var34 + String.valueOf(ChatColor.AQUA) + " - " + String.valueOf(ChatColor.GREEN) + String.valueOf(var31.get(var34)) + " 格之外" + String.valueOf(ChatColor.AQUA) + " - " + String.valueOf(ChatColor.RED) + var30.playerDisguise.get(var34).getType().name());
                                    ++var11;
                                }
                                var2.sendMessage(" ");
                                var2.sendMessage(String.valueOf(ChatColor.DARK_AQUA) + "      =================================== ");
                                return;
                            }
                        }
                        if (var7.getItemMeta().hasDisplayName() && var7.getItemMeta().getDisplayName().contains(this.plugin.powerup_marker)) {
                            var1.setCancelled(true);
                            final Arena var8 = this.plugin.playerData.get(var2.getName()).arena;
                            if (var8.hiders.contains(var2.getName())) {
                                if (var7.getType().equals((Object)Material.TNT)) {
                                    final TNTPrimed var29 = (TNTPrimed)var2.getWorld().spawn(var2.getLocation().add(0.0, 1.0, 0.0), (Class)TNTPrimed.class);
                                    var29.setMetadata("damageSeekers", (MetadataValue)new FixedMetadataValue((Plugin)this.plugin, (Object)true));
                                    var29.setFuseTicks(40);
                                }
                                else if (var7.getType().equals((Object)Material.EMERALD)) {
                                    final int var35 = Utils.random.nextInt(Config.getInstance().powerup_coins_max - Config.getInstance().powerup_coins_min) + Config.getInstance().powerup_coins_min;
                                    final PlayerData var36 = this.plugin.playerData.get(var2.getName());
                                    var36.addCoins(var2, var35);
                                    final PlayerData playerData3 = var36;
                                    playerData3.currentGameCoins += var35;
                                    var2.sendMessage(this.plugin.customization.messages.get("coins_powerup").replace("%coins%", String.valueOf(var35)));
                                }
                                else if (XMaterial.BREWING_STAND.isSimilar(var7)) {
                                    var2.addPotionEffect(new PotionEffect(PotionEffectType.SPEED, 300, 1));
                                    var2.addPotionEffect(new PotionEffect(PotionEffectType.INCREASE_DAMAGE, 160, 0));
                                }
                                else if (XMaterial.CLOCK.isSimilar(var7)) {
                                    final String var5 = this.plugin.customization.messages.get("powerup_effect_seekers").replace("%player%", var2.getName()) + " (失明 和 缓慢)";
                                    for (final Player var38 : var8.getPlayers(true)) {
                                        var38.sendMessage(var5);
                                        if (var8.seekers.contains(var38.getName())) {
                                            var38.addPotionEffect(new PotionEffect(PotionEffectType.SLOW, 200, 1));
                                            var38.addPotionEffect(new PotionEffect(PotionEffectType.BLINDNESS, 200, 0));
                                        }
                                    }
                                }
                                else if (var7.getType().equals((Object)Material.BRICK)) {
                                    final ArrayList var16 = Utils.getRoom(var2.getLocation());
                                    boolean var39 = true;
                                    for (final Location var40 : var16) {
                                        if (var40.getBlock().getType() != Material.AIR) {
                                            var39 = false;
                                            break;
                                        }
                                    }
                                    if (!var39) {
                                        var2.sendMessage((String)this.plugin.customization.messages.get("powerup_nospace"));
                                        return;
                                    }
                                    final ArrayList var41 = new ArrayList();
                                    for (final Location var42 : var16) {
                                        var41.add(var42.getBlock().getState());
                                        var42.getBlock().setType(XMaterial.BRICKS.parseMaterial());
                                    }
                                    var16.get(0).getBlock().setType(Material.GLOWSTONE);
                                    this.plugin.toRollback.addAll(var41);
                                    final ArrayList var43 = new ArrayList();
                                    for (final Entity var44 : var2.getNearbyEntities(10.0, 10.0, 10.0)) {
                                        if (var44.getType().equals((Object)EntityType.PLAYER)) {
                                            final Player var45 = (Player)var44;
                                            if (!var8.seekers.contains(var45.getName())) {
                                                continue;
                                            }
                                            var43.add(var45);
                                            var45.damage(2.0, (Entity)var2);
                                        }
                                    }
                                    var2.teleport(var2.getLocation().add(0.0, 10.0, 0.0));
                                    for (final Player var46 : var43) {
                                        var46.teleport((Entity)var2);
                                    }
                                    for (int var28 = 0; var28 < 6; ++var28) {
                                        final TNTPrimed var47 = (TNTPrimed)var2.getWorld().spawn(var2.getLocation().add(0.0, 1.0, 0.0), (Class)TNTPrimed.class);
                                        var47.setMetadata("damageSeekers", (MetadataValue)new FixedMetadataValue((Plugin)this.plugin, (Object)true));
                                        var47.setFuseTicks(40 + var28 * 5);
                                    }
                                    if (!var43.isEmpty()) {
                                        final String var34 = this.plugin.customization.messages.get("powerup_effect_seekers").replace("%player%", var2.getName()) + " (死亡牢笼)";
                                        for (final Player var45 : var8.getPlayers(true)) {
                                            var45.sendMessage(var34);
                                        }
                                    }
                                    Bukkit.getScheduler().scheduleSyncDelayedTask((Plugin)this.plugin, (Runnable)new Runnable() {
                                        @Override
                                        public void run() {
                                            for (final BlockState var2 : var41) {
                                                HASListener.this.plugin.Rollback(var2);
                                            }
                                            HASListener.this.plugin.toRollback.removeAll(var41);
                                        }
                                    }, 100L);
                                }
                                if (var2.getItemInHand().getAmount() > 1) {
                                    var2.getItemInHand().setAmount(var2.getItemInHand().getAmount() - 1);
                                }
                                else {
                                    var2.setItemInHand(new ItemStack(Material.AIR));
                                }
                            }
                            else {
                                var2.setItemInHand((ItemStack)null);
                            }
                        }
                    }
                }
            }
            if (var1.getAction().equals((Object)Action.LEFT_CLICK_BLOCK)) {
                final Location var49 = var1.getClickedBlock().getLocation();
                if (this.plugin.disguisedBlocks.containsKey(var49)) {
                    final Player var50 = Bukkit.getPlayer((String)this.plugin.disguisedBlocks.get(var49));
                    if (!this.plugin.isOnSameTeam(var2, var50)) {
                        final Arena var30 = this.plugin.playerData.get(var50.getName()).arena;
                        this.plugin.disguisedBlocks.remove(var49);
                        var30.hidden.remove(var50.getName());
                        var30.nonhidden.add(var50.getName());
                        var30.stillCounter.put(var50.getName(), var30.hiders_become_solid_after);
                        var50.setLevel(var30.hiders_become_solid_after);
                        for (final Player var38 : var30.getPlayers(true)) {
                            var38.showPlayer(var50);
                            this.plugin.sendBlockChange(var38, var49, Material.AIR, 0);
                        }
                        var50.setVelocity(new Vector(0.0, 0.5, 0.0));
                        Utils.playSound(var2, "Hider-Exposed");
                        Utils.playSound(var50, "Hider-Exposed");
                    }
                }
            }
        }
    }
    
    @EventHandler
    public void onEntityDamage(final EntityDamageEvent var1) {
        if (!var1.isCancelled() && var1.getEntity().getType().equals((Object)EntityType.PLAYER)) {
            final Player var2 = (Player)var1.getEntity();
            if (this.plugin.game.contains(var2.getName()) && (this.plugin.grace.contains(var2.getName()) || (var1.getCause().equals((Object)EntityDamageEvent.DamageCause.FALL) && !Config.getInstance().FallDamageEnabled))) {
                var1.setCancelled(true);
            }
        }
    }
    
    @EventHandler
    public void onEntityDamageByEntity(final EntityDamageByEntityEvent var1) {
        if (!var1.isCancelled() && var1.getEntity().getType().equals((Object)EntityType.PLAYER)) {
            final Player var2 = (Player)var1.getEntity();
            if (this.plugin.game.contains(var2.getName())) {
                if (var1.getDamager().getType().equals((Object)EntityType.FIREWORK) && !Config.getInstance().FireworkDamageEnabled) {
                    var1.setCancelled(true);
                    return;
                }
                final boolean var3 = var1.getDamager() instanceof Projectile;
                Player var4 = null;
                if (var3) {
                    final ProjectileSource var5 = ((Projectile)var1.getDamager()).getShooter();
                    if (var5 instanceof final Player player) {
                        var4 = player;
                    }
                }
                else if (var1.getDamager().getType().equals((Object)EntityType.PLAYER)) {
                    var4 = (Player)var1.getDamager();
                }
                else {
                    if (var1.getDamager().hasMetadata("damageSeekers")) {
                        final Arena var6 = this.plugin.playerData.get(var2.getName()).arena;
                        if (var6.hiders.contains(var2.getName())) {
                            var1.setCancelled(true);
                        }
                        return;
                    }
                    if (var1.getDamager().hasMetadata("damageHiders")) {
                        final Arena var6 = this.plugin.playerData.get(var2.getName()).arena;
                        if (var6.seekers.contains(var2.getName())) {
                            var1.setCancelled(true);
                        }
                        return;
                    }
                }
                if (var4 != null && this.plugin.game.contains(var4.getName())) {
                    if (this.plugin.isOnSameTeam(var2, var4)) {
                        var1.setCancelled(true);
                    }
                    else {
                        Utils.playSound(var2, "Player-Hit-Player");
                    }
                }
            }
        }
    }
    
    @EventHandler
    public void onEntityShootBowEvent(final ProjectileLaunchEvent var1) {
        final Projectile var2 = var1.getEntity();
        if (var2.getShooter() != null && var2.getShooter() instanceof Player) {
            final Player var3 = (Player)var2.getShooter();
            if (this.plugin.game.contains(var3.getName())) {
                final PlayerData var4 = this.plugin.playerData.get(var3.getName());
                if (var4.selectedTrail != null) {
                    final World var5 = var3.getWorld();
                    final Effect var6 = var4.selectedTrail;
                    new BukkitRunnable() {
                        public void run() {
                            var5.playEffect(var2.getLocation(), var6, 1);
                            for (int var1 = 1; var1 < Config.getInstance().trailsSize; ++var1) {
                                var5.playEffect(var2.getLocation().add(Utils.random.nextDouble(), Utils.random.nextDouble(), Utils.random.nextDouble()), var6, 1);
                            }
                            if (!var2.isValid() || var2.isOnGround() || var2.getLocation().getY() < 0.0) {
                                this.cancel();
                            }
                        }
                    }.runTaskTimer((Plugin)this.plugin, 0L, (long)Config.getInstance().trailsInterval);
                }
            }
        }
    }
    
    @EventHandler
    public void PlayerCloseInventory(final InventoryCloseEvent var1) {
        final String var2 = var1.getPlayer().getName();
        this.plugin.shopping.remove(var2);
    }
    
    @EventHandler
    public void onPlayerDeath(final PlayerDeathEvent var1) {
        final Player var2 = var1.getEntity();
        if (this.plugin.game.contains(var2.getName())) {
            var1.setDeathMessage((String)null);
            var1.getDrops().clear();
            final Arena var3 = this.plugin.playerData.get(var2.getName()).arena;
            var2.sendMessage((String)this.plugin.customization.messages.get("player_death"));
            final Player var4 = (var2.getKiller() != null && this.plugin.game.contains(var2.getKiller().getName())) ? var2.getKiller() : null;
            final ChatColor var5 = (var4 != null) ? (var3.seekers.contains(var4.getName()) ? ChatColor.RED : ChatColor.GREEN) : null;
            final String var6 = (var5 != null) ? ((var5 == ChatColor.RED) ? (String.valueOf(ChatColor.RED) + "Seeker") : (String.valueOf(ChatColor.GREEN) + "Hider")) : null;
            String var7;
            if (var4 != null) {
                var7 = this.plugin.customization.messages.get("player_death_by_player_broadcast").replace((CharSequence)"%team%", var3.seekers.contains(var2.getName()) ? (String.valueOf(ChatColor.RED) + "Seeker") : (String.valueOf(ChatColor.GREEN) + "Hider")).replace("%player%", var2.getName()).replace((CharSequence)"%killer%", var6 + " " + var4.getName());
            }
            else {
                var7 = this.plugin.customization.messages.get("player_death_broadcast").replace((CharSequence)"%team%", var3.seekers.contains(var2.getName()) ? (String.valueOf(ChatColor.RED) + "Seeker") : (String.valueOf(ChatColor.GREEN) + "Hider")).replace("%player%", var2.getName());
            }
            for (final Player var9 : var3.getPlayers(true)) {
                var9.sendMessage(var7);
            }
            if (XMaterial.supports(8)) {
                new BukkitRunnable() {
                    public void run() {
                        var2.spigot().respawn();
                    }
                }.runTaskLater((Plugin)HideAndSeek.getInstance(), 1L);
            }
            else {
                var2.setHealth(var2.getMaxHealth());
                var2.setFallDistance(0.0f);
                var2.setFireTicks(0);
                var2.getInventory().clear();
                for (final PotionEffect var10 : var2.getActivePotionEffects()) {
                    var2.removePotionEffect(var10.getType());
                }
                if (this.plugin.playerData.get(var2.getName()).hasPerk(Perk.SeekerSpeed)) {
                    var2.addPotionEffect(new PotionEffect(PotionEffectType.SPEED, 9999999, 0));
                }
                for (final PotionEffect var10 : var3.seekerEffects) {
                    var2.addPotionEffect(var10);
                }
            }
            if (var3.seekers.contains(var2.getName())) {
                if (var4 != null) {
                    final int var11 = this.plugin.playerData.get(var4.getName()).modifier;
                    final int var12 = Config.getInstance().HiderKillSeekerEarnedCoins * var11;
                    final int var13 = Utils.getRandomFromInterval(Config.getInstance().HiderKillSeekerMinEarnedExp, Config.getInstance().HiderKillSeekerMaxEarnedExp) * var11;
                    this.playerKill(var4, var12, var13, true);
                    var4.sendMessage(this.plugin.customization.messages.get("player_kill").replace("%earnedCoins%", String.valueOf(var12)).replace("%earnedExp%", String.valueOf(var13)) + " " + ((var11 != 1) ? /* invokedynamic(!) */ProcyonInvokeDynamicHelper_10.invoke(var11) : ""));
                }
                var3.respawnSeeker(var2, true);
            }
            else if (var3.hiders.contains(var2.getName())) {
                if (var4 != null) {
                    final int var11 = this.plugin.playerData.get(var4.getName()).modifier;
                    final int var12 = Config.getInstance().SeekerKillHiderEarnedCoins * var11;
                    final int var13 = Utils.getRandomFromInterval(Config.getInstance().SeekerKillHiderMinEarnedExp, Config.getInstance().SeekerKillHiderMaxEarnedExp) * var11;
                    this.playerKill(var4, var12, var13, false);
                    var4.sendMessage(this.plugin.customization.messages.get("player_kill").replace("%earnedCoins%", String.valueOf(var12)).replace("%earnedExp%", String.valueOf(var13)) + " " + ((var11 != 1) ? /* invokedynamic(!) */ProcyonInvokeDynamicHelper_11.invoke(var11) : ""));
                }
                var3.moveHiderToSeeker(var2);
                if (var3.hiders.isEmpty()) {
                    var3.finishGame(false);
                }
            }
        }
    }
    
    @EventHandler
    public void onPlayerRespawn(final PlayerRespawnEvent var1) {
        final Player var2 = var1.getPlayer();
        if (this.plugin.game.contains(var2.getName())) {
            final Arena var3 = this.plugin.playerData.get(var2.getName()).arena;
            var1.setRespawnLocation(var3.seekersWaitingSpawn);
            new BukkitRunnable() {
                public void run() {
                    if (var3.seekers.contains(var2.getName())) {
                        if (HASListener.this.plugin.playerData.get(var2.getName()).hasPerk(Perk.SeekerSpeed)) {
                            var2.addPotionEffect(new PotionEffect(PotionEffectType.SPEED, 9999999, 0));
                        }
                        for (final PotionEffect var2x : var3.seekerEffects) {
                            var2.addPotionEffect(var2x);
                        }
                    }
                }
            }.runTaskLater((Plugin)HideAndSeek.getInstance(), 1L);
        }
    }
    
    @EventHandler
    public void onPlayerChat(final PlayerChatEvent var1) {
        final Player var2 = var1.getPlayer();
        if (this.plugin.game.contains(var2.getName())) {
            if (Config.getInstance().karmaEnabled) {
                final String var3 = ChatColor.stripColor(var1.getMessage().toLowerCase());
                if (var3.contains("gg") || var3.contains("good game") || var3.contains("goodgame")) {
                    final PlayerData var4 = this.plugin.playerData.get(var2.getName());
                    if (var4.arena != null && var4.arena.state.equals((Object)Arena.ArenaState.ENDING)) {
                        if (var4.hasCooldown(var2, "gg", 20, false)) {
                            return;
                        }
                        final int var5 = Utils.random.nextInt(Config.getInstance().maxKarmaForSayingGG - Config.getInstance().minKarmaForSayingGG) + Config.getInstance().minKarmaForSayingGG;
                        final PlayerData playerData;
                        final PlayerData var6 = playerData = this.plugin.playerData.get(var2.getName());
                        playerData.karma += var5;
                        var2.sendMessage(this.plugin.customization.messages.get("player_earn_karma").replace("%earnedKarma%", String.valueOf(var5)));
                    }
                }
            }
            if (Config.getInstance().modifychat) {
                final PlayerData var7 = this.plugin.playerData.get(var2.getName());
                var1.setFormat(Config.getInstance().chatModification.replace("%rank%", var7.rank.name).replace("%coins%", String.valueOf(var7.getCoins(var2))).replace("%exp%", String.valueOf(var7.playerExp)) + " " + var1.getFormat());
            }
        }
    }
    
    @EventHandler
    public void onPlayerCreateSign(final SignChangeEvent var1) {
        final Player var2 = var1.getPlayer();
        if (var1.getLine(0).equalsIgnoreCase("[Has]")) {
            if (var2.hasPermission("hideandseek.createsigns")) {
                var1.setLine(0, this.plugin.customization.sign_prefix);
                final String var3 = var1.getLine(1).toLowerCase();
                if (!var3.equals("stats") && !var3.equals("leave") && !var3.equals("join") && !var3.equals("autojoin") && !var3.equals("shop") && !var3.equals("top")) {
                    var2.sendMessage(this.plugin.customization.prefix + "Second line must be one of these options, join/leave/stats/autojoin/top");
                    var1.setLine(1, String.valueOf(ChatColor.DARK_RED) + "Wrong");
                }
                else if (var3.equals("stats")) {
                    var1.setLine(1, this.plugin.customization.sign_stats);
                    var2.sendMessage(this.plugin.customization.prefix + "You have created a " + String.valueOf(ChatColor.YELLOW) + var3 + String.valueOf(ChatColor.GOLD) + " sign!");
                }
                else if (var3.equals("leave")) {
                    var1.setLine(1, this.plugin.customization.sign_leave);
                    var2.sendMessage(this.plugin.customization.prefix + "You have created a " + String.valueOf(ChatColor.YELLOW) + var3 + String.valueOf(ChatColor.GOLD) + " sign!");
                }
                else if (var3.equals("join")) {
                    final Arena var4 = Arena.valueOf(var1.getLine(2));
                    if (var4 == null) {
                        if (this.plugin.joinGui != null) {
                            var1.setLine(1, this.plugin.customization.sign_join_default);
                            var1.setLine(2, "");
                            var1.setLine(3, "");
                            var2.sendMessage(this.plugin.customization.prefix + "Couldn't find an arean with a name mentioned in the second line, due to that, no arena was specified!");
                        }
                        else {
                            var2.sendMessage((String)this.plugin.customization.messages.get("unknown_arena"));
                        }
                        return;
                    }
                    if (FilesManager.getInstance().getConfig("signs.yml").contains("Signs.Join." + var4.name)) {
                        var2.sendMessage(this.plugin.customization.prefix + "You may not have more than 1 join sign per arena!");
                        return;
                    }
                    final Location var5 = var1.getBlock().getLocation();
                    final String var6 = var5.getWorld().getName();
                    final int var7 = var5.getBlockX();
                    final int var8 = var5.getBlockY();
                    final int var9 = var5.getBlockZ();
                    FilesManager.getInstance().getConfig("signs.yml").set("Signs.Join." + var4.name, var6 + ", " + var7 + ", " + var8 + ", " + var9);
                    FilesManager.getInstance().saveConfig("signs.yml");
                    var4.sign = var5;
                    var1.setLine(1, String.valueOf(this.plugin.customization.sign_join_line2_color) + var4.name);
                    var1.setLine(2, var4.state.text);
                    var1.setLine(3, this.plugin.customization.sign_join_line4_format.replace("%players%", String.valueOf(var4.players.size())).replace("%maxplayers%", String.valueOf(var4.maxPlayers)));
                    var4.updateBehindSign();
                    var4.updateStateBlock();
                    var2.sendMessage(this.plugin.customization.prefix + "You have created a " + String.valueOf(ChatColor.YELLOW) + var3 + String.valueOf(ChatColor.GOLD) + " sign!");
                }
                else if (var3.equals("autojoin")) {
                    var1.setLine(1, this.plugin.customization.sign_autojoin);
                    var2.sendMessage(this.plugin.customization.prefix + "You have created a " + String.valueOf(ChatColor.YELLOW) + var3 + String.valueOf(ChatColor.GOLD) + " sign!");
                }
                else if (var3.equals("shop")) {
                    var1.setLine(1, this.plugin.customization.sign_shop);
                    var2.sendMessage(this.plugin.customization.prefix + "You have created a " + String.valueOf(ChatColor.YELLOW) + var3 + String.valueOf(ChatColor.GOLD) + " sign!");
                }
                else if (var3.equals("top")) {
                    if (Utils.isNumber(var1.getLine(2))) {
                        final int var10 = Integer.parseInt(var1.getLine(2));
                        if (var10 > 0) {
                            final FileConfiguration var11 = FilesManager.getInstance().getConfig("signs.yml");
                            final String var6 = "Signs.Top." + var10;
                            if (var11.contains(var6)) {
                                var2.sendMessage(this.plugin.customization.prefix + "You have already made a top sign that looks for the rank " + String.valueOf(ChatColor.AQUA) + var10);
                                return;
                            }
                            final Location var12 = var1.getBlock().getLocation();
                            var11.set(var6 + ".world", (Object)var12.getWorld().getName());
                            var11.set(var6 + ".x", (Object)var12.getX());
                            var11.set(var6 + ".y", (Object)var12.getY());
                            var11.set(var6 + ".z", (Object)var12.getZ());
                            FilesManager.getInstance().saveConfig("signs.yml");
                            var1.setLine(1, "Top #" + var10);
                            var1.setLine(2, "WAITING");
                            var1.setLine(3, "(0)");
                            var2.sendMessage(this.plugin.customization.prefix + "You have created a " + String.valueOf(ChatColor.YELLOW) + var3 + String.valueOf(ChatColor.GOLD) + " sign!");
                            if (this.plugin.fixUpdater()) {
                                var2.sendMessage(this.plugin.customization.prefix + "Sign updater has been enabled");
                            }
                            else {
                                var2.sendMessage(this.plugin.customization.prefix + "Sign updater is already enabled, so you must wait till next update to see results");
                            }
                        }
                        else {
                            var2.sendMessage(this.plugin.customization.prefix + "Third line must be a number above 0");
                        }
                    }
                    else {
                        var2.sendMessage(this.plugin.customization.prefix + "Third line must be a number (Its the rank you want to display)");
                    }
                }
            }
            else {
                var2.sendMessage((String)this.plugin.customization.messages.get("no_permission"));
                var1.setCancelled(true);
            }
        }
    }
    
    @EventHandler
    public void onPlayerMove(final PlayerMoveEvent var1) {
        final Player var2 = var1.getPlayer();
        if (this.plugin.disguisedBlocks.containsValue(var2.getName())) {
            final Location var3 = var1.getFrom();
            final Location var4 = var1.getTo();
            if (var3.getBlockX() != var4.getBlockX() || var3.getY() != var4.getY() || var3.getBlockZ() != var4.getBlockZ()) {
                var2.sendMessage((String)this.plugin.customization.messages.get("player_move"));
                this.plugin.disguisedBlocks.remove(var3.getBlock().getLocation());
                final Arena var5 = this.plugin.playerData.get(var2.getName()).arena;
                var5.hidden.remove(var2.getName());
                var5.nonhidden.add(var2.getName());
                final int var6 = this.plugin.playerData.get(var2.getName()).hasPerk(Perk.InstaSolid) ? 1 : var5.hiders_become_solid_after;
                var5.stillCounter.put(var2.getName(), var6);
                var2.setLevel(var6);
                for (final Player var8 : var5.getPlayers(true)) {
                    var8.showPlayer(var2);
                    this.plugin.sendBlockChange(var8, var3, Material.AIR, 0);
                }
            }
        }
    }
    
    @EventHandler
    public void blockCommand(final PlayerCommandPreprocessEvent var1) {
        final Player var2 = var1.getPlayer();
        if (!var2.hasPermission("hideandseek.unblockcommands")) {
            final String var3 = var1.getMessage().split(" ")[0].replace("/", "").toLowerCase();
            if (this.plugin.game.contains(var2.getName()) && !Config.getInstance().allowedCommands.contains(var3)) {
                var1.setCancelled(true);
                var2.sendMessage((String)this.plugin.customization.messages.get("blocked_cmd"));
            }
        }
    }
    
    @EventHandler
    public void onTeleport(final PlayerTeleportEvent var1) {
        final Player var2 = var1.getPlayer();
        if (this.plugin.game.contains(var2.getName())) {
            final Arena var3 = this.plugin.playerData.get(var2.getName()).arena;
            if (var3.hidden.contains(var2.getName())) {
                var3.hidden.remove(var2.getName());
                var3.nonhidden.add(var2.getName());
                var3.removeHidden(var2);
            }
        }
    }
    
    @EventHandler
    public void onPing(final ServerListPingEvent var1) {
        if (Config.getInstance().bungeeEnabled) {
            if (this.plugin.bungeeMode.selectedArena != null) {
                if (this.plugin.bungeeMode.selectedArena.state.equals((Object)Arena.ArenaState.WAITING)) {
                    var1.setMotd(Arena.ArenaState.INGAME.text);
                }
                else {
                    var1.setMotd(this.plugin.bungeeMode.selectedArena.state.text);
                }
            }
            else {
                var1.setMotd(Arena.ArenaState.WAITING.text);
            }
        }
    }
    
    public void playerKill(final Player var1, final int var2, final int var3, final boolean var4) {
        final PlayerData var5 = this.plugin.playerData.get(var1.getName());
        if (var4) {
            final PlayerData playerData = var5;
            ++playerData.seekersKilled;
            AchievementsManager.getInstance().checkPlayer(var1, AchievementsManager.AchievementType.SEEKERS_KILLED, var5.seekersKilled);
        }
        else {
            final PlayerData playerData2 = var5;
            ++playerData2.hidersKilled;
            AchievementsManager.getInstance().checkPlayer(var1, AchievementsManager.AchievementType.HIDERS_KILLED, var5.hidersKilled);
        }
        var5.addCoins(var1, var2);
        final PlayerData playerData3 = var5;
        playerData3.playerExp += var3;
        final PlayerData playerData4 = var5;
        playerData4.currentGameCoins += var2;
        final PlayerData playerData5 = var5;
        playerData5.currentGameExp += var3;
        if (var5.rank.nextRank != null && var5.rank.nextRank.requiredExp <= var5.playerExp) {
            var5.rank = var5.rank.nextRank;
            for (final String var7 : var5.rank.commandsExecuted) {
                Bukkit.dispatchCommand((CommandSender)this.plugin.console, var7.replace("%player%", var1.getName()).replace("%newrank%", var5.rank.name));
            }
            final Arena var8 = this.plugin.playerData.get(var1.getName()).arena;
            String var7 = this.plugin.customization.messages.get("rankup_broadcast").replace("%player%", var1.getName()).replace("%rank%", var5.rank.name);
            for (final Player var10 : var8.getPlayers(true)) {
                var10.sendMessage(var7);
            }
        }
    }
    
    // This helper class was generated by Procyon to approximate the behavior of an
    // 'invokedynamic' instruction that it doesn't know how to interpret.
    private static final class ProcyonInvokeDynamicHelper_10
    {
        private static final MethodHandles.Lookup LOOKUP = MethodHandles.lookup();
        private static MethodHandle handle;
        private static volatile int fence;
        
        private static MethodHandle handle() {
            final MethodHandle handle = ProcyonInvokeDynamicHelper_10.handle;
            if (handle != null)
                return handle;
            return ProcyonInvokeDynamicHelper_10.ensureHandle();
        }
        
        private static MethodHandle ensureHandle() {
            ProcyonInvokeDynamicHelper_10.fence = 0;
            MethodHandle handle = ProcyonInvokeDynamicHelper_10.handle;
            if (handle == null) {
                MethodHandles.Lookup lookup = ProcyonInvokeDynamicHelper_10.LOOKUP;
                try {
                    handle = ((CallSite)StringConcatFactory.makeConcatWithConstants(lookup, "makeConcatWithConstants", MethodType.methodType(String.class, int.class), "(x\u0001)")).dynamicInvoker();
                }
                catch (Throwable t) {
                    throw new UndeclaredThrowableException(t);
                }
                ProcyonInvokeDynamicHelper_10.fence = 1;
                ProcyonInvokeDynamicHelper_10.handle = handle;
                ProcyonInvokeDynamicHelper_10.fence = 0;
            }
            return handle;
        }
        
        private static String invoke(int p0) {
            try {
                return ProcyonInvokeDynamicHelper_10.handle().invokeExact(p0);
            }
            catch (Throwable t) {
                throw new UndeclaredThrowableException(t);
            }
        }
    }
    
    // This helper class was generated by Procyon to approximate the behavior of an
    // 'invokedynamic' instruction that it doesn't know how to interpret.
    private static final class ProcyonInvokeDynamicHelper_11
    {
        private static final MethodHandles.Lookup LOOKUP = MethodHandles.lookup();
        private static MethodHandle handle;
        private static volatile int fence;
        
        private static MethodHandle handle() {
            final MethodHandle handle = ProcyonInvokeDynamicHelper_11.handle;
            if (handle != null)
                return handle;
            return ProcyonInvokeDynamicHelper_11.ensureHandle();
        }
        
        private static MethodHandle ensureHandle() {
            ProcyonInvokeDynamicHelper_11.fence = 0;
            MethodHandle handle = ProcyonInvokeDynamicHelper_11.handle;
            if (handle == null) {
                MethodHandles.Lookup lookup = ProcyonInvokeDynamicHelper_11.LOOKUP;
                try {
                    handle = ((CallSite)StringConcatFactory.makeConcatWithConstants(lookup, "makeConcatWithConstants", MethodType.methodType(String.class, int.class), "(x\u0001)")).dynamicInvoker();
                }
                catch (Throwable t) {
                    throw new UndeclaredThrowableException(t);
                }
                ProcyonInvokeDynamicHelper_11.fence = 1;
                ProcyonInvokeDynamicHelper_11.handle = handle;
                ProcyonInvokeDynamicHelper_11.fence = 0;
            }
            return handle;
        }
        
        private static String invoke(int p0) {
            try {
                return ProcyonInvokeDynamicHelper_11.handle().invokeExact(p0);
            }
            catch (Throwable t) {
                throw new UndeclaredThrowableException(t);
            }
        }
    }
}
